/*********************************************************
 * QUACQ (Quick Acquisition) Algorithm
 * @ref IJCAI13
 * 
 * @author LAZAAR
 * @date 2016-07-29
 ********************************************************/

package ag;

import config.Heuristic;
import config.Query_type;



public interface ACQ_Acquisition {

	// main acquisition process
        public boolean process();
	//main findScope process
	public ACQ_Scope findScope(ACQ_Query negative_example, ACQ_Scope X,  ACQ_Scope Bgd, boolean mutex);
	
	//main findC process
	public ACQ_IConstraint findC(ACQ_Scope scope, ACQ_Query negative_example, boolean normalizedCSP);

	//main query generator process
	/****************************************************************************
	 * query_gen
	 * 
	 * @param network1
	 * @param network2
	 * @param scope
	 * @param type
	 * @return Query
	 * @author LAZAAR
	 * @date 03-10-2017
	 * 
	 * get a query of type "type" on scope "scope" s.t., network1 and not network2
	 *****************************************************************************/
	public ACQ_Query query_gen(ACQ_Network network1, ACQ_Network network2, ACQ_Scope scope, Query_type type, Heuristic h);
	

}
