package ag;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.variables.BoolVar;
import org.chocosolver.solver.variables.IntVar;

public class ACQ_ConjuctionConstraint extends ACQ_Constraint{



	ACQ_Constraint constraint1;
	ACQ_Constraint constraint2;
	String id1;
	String id2;



	public ACQ_ConjuctionConstraint(ACQ_IConstraint c1, ACQ_IConstraint c2) {

		super(c1.toString()+"/\\"+c2.toString(), mergeArrays(c1.getVariables(), c2.getVariables()));
		this.constraint1=(ACQ_Constraint) c1;
		this.constraint2=(ACQ_Constraint) c2;

	}
	@Override
	public ACQ_IConstraint getNegation() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void toChoco(Model model, IntVar... intVars) {
		constraint1.toChoco(model, intVars);
		constraint2.toChoco(model, intVars);


	}

	@Override
	/****
	 * b <=> C1 and C2 :
	 * C1 <=> b1
	 * C2 <=> b2
	 * b=b1*b2
	 */
	public void toReifiedChoco(Model model, BoolVar b, IntVar... intVars) {
		BoolVar[] reifyArray = model.boolVarArray(2);

		constraint1.toReifiedChoco(model, reifyArray[0], intVars);
		constraint2.toReifiedChoco(model, reifyArray[1], intVars);
		model.arithm(reifyArray[0], "*", reifyArray[1], "=", b).post();

	}

	@Override
	protected boolean check(int... value) {

		return constraint1.check(value) && constraint2.check(value);
	}


	public static int[] mergeArrays(int[] arr1, int[] arr2){
		int[] merged = new int[arr1.length + arr2.length];
		System.arraycopy(arr1, 0, merged, 0, arr1.length);
		System.arraycopy(arr2, 0, merged, arr1.length, arr2.length);

		Set<Integer> nodupes = new HashSet<Integer>();

		for(int i=0;i<merged.length;i++){
			nodupes.add(merged[i]);
		}

		int[] nodupesarray = new int[nodupes.size()];
		int i = 0;

		Iterator<Integer> it = nodupes.iterator();
		while(it.hasNext()){
			nodupesarray[i] = it.next();
			i++;
		}



		return nodupesarray;
	}

}
