package ag;

public class StatManager {
	
	private int nb_var;
	
	// Stats counters
	
	private int nb_partial_query;
	private int nb_complete_query;
	private int nb_positive_query;
	private int nb_negative_query;
	private int query_size;
	
	public StatManager(int nb) {
		nb_partial_query = 0;
		nb_complete_query = 0;
		nb_positive_query = 0;
		nb_negative_query = 0;
		query_size = 0;
		nb_var = nb;
	}
	
	public void update(ACQ_Query e) {
		if(e.isPositive()) {
			nb_positive_query++;
			if(e.getScope().size() == nb_var)
				nb_complete_query++;
			else 
				nb_partial_query++;
		}else {
			nb_negative_query++;
			if(e.getScope().size() == nb_var)
				nb_complete_query++;
			else
				nb_partial_query++;
		}
		query_size += e.getScope().size();
	}
	
	public int getNbPartialQuery() {
		return nb_partial_query;
	}
	
	public int getNbCompleteQuery() {
		return nb_complete_query;
	}
	
	public int getNbPositiveQuery() {
		return nb_positive_query;
	}
	
	public int getNbNegativeQuery() {
		return nb_negative_query;
	}
	
	public float getQuerySize() {
		return (float)query_size/(nb_partial_query+nb_complete_query);
	}
	
	@Override
	public String toString() {
		String res = "";
		res += "Total queries : " + (nb_complete_query + nb_partial_query);
		res += "\nComplete queries : " + nb_complete_query;
		res += "\nPartial queries : " + nb_partial_query;
		res += "\nPositive queries : " + nb_positive_query;
		res += "\nNegative queries : " + nb_negative_query;
		res += "\nAverage query size : " + getQuerySize();
		return res;
	}
}
