/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ag;

import acqConstraints.Operator;
import org.chocosolver.solver.Model;
import org.chocosolver.solver.variables.BoolVar;
import org.chocosolver.solver.variables.IntVar;

/**
 *
 * @author agutierr
 */
public class UnaryArithmetic extends UnaryConstraint {
	final private Operator op;
	final private int cste;
	public UnaryArithmetic(String name, int var, Operator op, int cste){
		super(name,var);
		this.op=op;
		this.cste=cste;
	}
	@Override
	protected boolean check(int value) {
		switch (op) {
		case EQ:
			return value == cste;
		case NQ:
			return value != cste;
		case GT:
			return value > cste;
		case GE:
			return value >= cste;
		case LT:
			return value < cste;
		case LE:
			return value <= cste;
		}
		return false;

	}
	@Override
	public UnaryArithmetic getNegation(){
		return new UnaryArithmetic(getName(),getScope().getFirst(),Operator.getOpposite(op),cste);
	}

	@Override
	public void toChoco(Model model,IntVar... intVars) {
		model.arithm(intVars[0], op.toString(), cste).post();
	}
	@Override
	public void toReifiedChoco(Model model, BoolVar b, IntVar... intVars) {
		model.arithm(intVars[0], op.toString(), cste).reifyWith(b);

	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + cste;
		result = prime * result + ((op == null) ? 0 : op.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UnaryArithmetic other = (UnaryArithmetic) obj;
		if (cste != other.cste)
			return false;
		if (op != other.op)
			return false;
		return true;
	}
}
