/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ag.expe;

import acqConstraints.Operator;
import ag.ACQ_Bias;
import ag.ACQ_ChocoSolver;
import ag.ACQ_ConstraintSet;
import ag.ACQ_ConstraintSolver;
import ag.ACQ_Domain;
import ag.ACQ_Learner;
import ag.ACQ_Network;
import ag.ACQ_QUACQ;
import ag.ACQ_Query;
import ag.ACQ_Scope;
import ag.BinaryArithmetic;
import combinatorial.AllPermutationIterator;
import combinatorial.CombinationIterator;
import config.Heuristic;
import java.util.BitSet;
import java.util.HashMap;
import java.util.Scanner;

/**
 * AllDiff experiment
 * @author NADJIB
 */
public class ExpeTOY extends Experience{



	public ExpeTOY(boolean auto_learn) {
		super(auto_learn);
	}

	public ACQ_ConstraintSolver createSolver() {
		return new ACQ_ChocoSolver(new ACQ_Domain() {
			@Override
			public int getMin(int numvar) {
				return 1;
			}

			@Override
			public int getMax(int numvar) {
				return 3;
			}
		});
	}

	public ACQ_Learner createLearner() {
		return new ACQ_Learner() {
			@Override
			public boolean ask(ACQ_Query e) {
				if(auto_learn) {
					int[] tuple = e.getTuple();  				
					for(int i=0; i<tuple.length-1; i++)
						for(int j=i+1; j<tuple.length; j++)
							if(tuple[i]==tuple[j]) {
								stats.update(e);
								return false;
							}
					stats.update(e);
					return true;
				}else 
					return getAnswer(e);

			}

		};
	}

	public ACQ_Bias createBias() {
		int NB_VARIABLE = 3;
		// build All variables set
		BitSet bs = new BitSet();
		bs.set(0, NB_VARIABLE);
		ACQ_Scope allVarSet = new ACQ_Scope(bs);
		// build Constraints
		ACQ_ConstraintSet constraints = new ACQ_ConstraintSet();
		CombinationIterator iterator = new CombinationIterator(NB_VARIABLE, 2);
		while (iterator.hasNext()) {
			int[] vars = iterator.next();
			AllPermutationIterator pIterator = new AllPermutationIterator(2);
			while (pIterator.hasNext()) {
				int[] pos = pIterator.next();
				if(vars[pos[0]]< vars[pos[1]])		//NL: commutative relations
				{
					// X != Y
					System.err.println(constraints.size()+ "var1:"+ vars[pos[0]]+ "var2:"+ vars[pos[1]]);
					constraints.add(new BinaryArithmetic("DifferentXY", vars[pos[0]], Operator.NQ, vars[pos[1]]));
					// X == Y
					System.err.println(constraints.size()+ "var1:"+ vars[pos[0]]+ "var2:"+ vars[pos[1]]);
					constraints.add(new BinaryArithmetic("EqualXY", vars[pos[0]], Operator.EQ, vars[pos[1]]));
					System.err.println(constraints.size()+ "var1:"+ vars[pos[0]]+ "var2:"+ vars[pos[1]]);
				}
				// X >= Y
				System.err.println(constraints.size()+ "var1:"+ vars[pos[0]]+ "var2:"+ vars[pos[1]]);
				constraints.add(new BinaryArithmetic("GreaterEqualXY", vars[pos[0]], Operator.GE, vars[pos[1]]));
				System.err.println(constraints.size()+ "var1:"+ vars[pos[0]]+ "var2:"+ vars[pos[1]]);
			}
		}
		ACQ_Network network = new ACQ_Network(allVarSet, constraints);
		return new ACQ_Bias(network);
	}

	public void learn() {
		ACQ_QUACQ acquisition = new ACQ_QUACQ(solver, bias, learner, heuristic);
		if (acquisition.process()) {
			System.out.println("YES");
			System.out.println(acquisition.getLearnedNetwork());

		} else {
			System.out.println("NO");
		}
	}

	public static void main(String args[]) {
		ExpeTOY expe = new ExpeTOY(true);
		expe.learn();

	}

}
