package ag.expe;
import java.util.Scanner;

import ag.*;
import config.Heuristic;
/**
 * Defined problems to illustrate the constraint acquisition
 * @author teddy
 *
 */
public abstract class Experience {
	
	boolean auto_learn;
	Heuristic heuristic = Heuristic.SOL;
	ACQ_ConstraintSolver solver;
	ACQ_Bias bias;
    ACQ_Learner learner;

	StatManager stats;
	
	public Experience(boolean auto_learn) {
		
		this.auto_learn = auto_learn;
		this.bias=createBias();
		this.learner=createLearner();
		this.solver= createSolver();
		stats = new StatManager(createBias().getVars().size());
	}
	
	public abstract ACQ_Bias createBias();
	
	public abstract ACQ_Learner createLearner();
	
	public abstract ACQ_ConstraintSolver createSolver();
	
	public void setHeuristic(Heuristic H) {
		this.heuristic=H;
	}
	
	public boolean getAnswer(ACQ_Query e) {
    	System.out.println("QUACQ");
    	System.out.println(e.toString());
		System.out.println("Is it a solution ? (y/n)");
		Scanner in = new Scanner(System.in);
		String userAnswer;
		do {
			userAnswer = in.next();
			System.out.println("You entered:" + userAnswer);
			if(!userAnswer.equals("y") && !userAnswer.equals("n")) {
				System.out.println("Incorrect answer.\n Please enter y or n.");
			}
		} while(!userAnswer.equals("y") && !userAnswer.equals("n"));
		if(userAnswer.equals("y")) {
			stats.update(e);
			return true;
		}
		else {
			stats.update(e);
			return false;
		}
    }
	
	public StatManager getStatManager() {
		return stats;
	}
	
}
