/*********************************************************
 * QUACQ (Quick Acquisition) Algorithm
 * @ref IJCAI13
 * 
 * @author LAZAAR
 * @date 2016-07-29
 ********************************************************/

package algo;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;

import acqConstraints.AcqConstraint;
import config.Heuristic;
import config.Query_type;
import vocabulary.*;
import machineLearning.*;


public interface Acquisition {

	
	// main acquisition process
	public  boolean quacq_process();

	//main findScope process
	public List<AcqVariable> findScope(Query negative_example, List<AcqVariable> X,  List<AcqVariable> Bgd, boolean mutex);
	
	//main findC process
	public AcqConstraint findC(List<AcqVariable> scope, Query negative_example);

	//main query generator process
	/****************************************************************************
	 * query_gen
	 * 
	 * @param network1
	 * @param network2
	 * @param scope
	 * @param type
	 * @return Query
	 * @author LAZAAR
	 * @date 03-10-2017
	 * 
	 * get a query of type "type" on scope "scope" s.t., network1 and not network2
	 *****************************************************************************/
	public Query query_gen(AcqNetwork network1, AcqNetwork network2, SortedSet<AcqVariable> scope, Query_type type, Heuristic h);
	

}
