package ag;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class ACQ_LearnerTest {

	private ACQ_Learner learner;
	
	@Before
	public void setUp() throws Exception {
		learner = new ACQ_Learner() {
			@Override
			public boolean ask(ACQ_Query e) {
				int[] tuple = e.getTuple();  				
				for(int i=0; i<tuple.length-1; i++)
					for(int j=i+1; j<tuple.length; j++) {
						System.out.println("i:"+i);
						System.out.println("j:"+j);
						System.out.println("tuple i:"+tuple[i]);
						System.out.println("tuple j:"+tuple[j]);
						if(tuple[i]==tuple[j]) 
							return false;
					}
				return true;
			}
		};
	}

	@Test
	public void testAsk() {
		
		learner = new ACQ_Learner() {
			@Override
			public boolean ask(ACQ_Query e) {
				int[] tuple = e.getTuple();  				
				for(int i=0; i<tuple.length-1; i++)
					for(int j=i+1; j<tuple.length; j++) {
						if(tuple[i]==tuple[j]) 
							return false;
					}
				return true;
			}
		};
		
		ACQ_Scope scope = new ACQ_Scope(0,1);
		int[] values = {2,5};
		ACQ_Query query = new ACQ_Query(scope, values);
		assertTrue(learner.ask(query));
		
		ACQ_Scope scope2 = new ACQ_Scope(0,1);
		int[] values2 = {3,3};
		ACQ_Query query2 = new ACQ_Query(scope2, values2);
		assertFalse(learner.ask(query2));
	}

	@Test
	public void testAsk1VarConstant(){
		
		learner = new ACQ_Learner() {
			@Override
			public boolean ask(ACQ_Query e) {
				int[] tuple = e.getTuple();  				
				for(int i=0; i<tuple.length; i++)
					if(tuple[i]!=5) 
						return false;
				return true;
			}
		};
		
		ACQ_Scope scope = new ACQ_Scope(0);
		int[] values = {2};
		ACQ_Query query = new ACQ_Query(scope, values);
		assertFalse(learner.ask(query));
		
		ACQ_Scope scope2 = new ACQ_Scope(1);
		int[] values2 = {5};
		ACQ_Query query2 = new ACQ_Query(scope2, values2);
		assertTrue(learner.ask(query2));
	}
}
