/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ag;

import acqConstraints.Operator;
import java.util.TreeSet;
import org.chocosolver.solver.Model;
import org.chocosolver.solver.variables.IntVar;

/**
 *
 * @author agutierr
 */
public class Test {

    public static void main(String [ ] args) {
        int NB_VARIABLE=5;
        // definitions de constraintes
        // A=2
        ACQ_IConstraint constraint1 = new UnaryConstraint("EqualX", 0) {
            @Override
            protected boolean check(int value) {
                return value == 2;
            }
            @Override
            public ACQ_IConstraint getNegation() {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }

            @Override
            public void toChoco(Model model, IntVar... intVars) {
                model.arithm(intVars[0], Operator.EQ.toString(), 2).post();
            }
        };
        // A!=B
        ACQ_IConstraint constraint2 = new BinaryConstraint("DifferentXY", 0, 1) {
            @Override
            protected boolean check(int value1, int value2) {
                return value1 != value2;
            }            
            @Override
            public ACQ_IConstraint getNegation() {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }

            @Override
            public void toChoco(Model model, IntVar... intVars) {
                model.arithm(intVars[0], Operator.NQ.toString(), intVars[1]);
            }
        };
        // A>C>D>E
        ACQ_IConstraint constraint3 = new ACQ_Constraint("BizarreWXYZ", new int[]{0, 2, 3, 4}) {

            @Override
            protected boolean check(int... value) {
                assert value.length==getArity(); // garanti parce que la méthode checker ne peut etre redéfinie (final)
                return value[0] > value[1] && value[1] > value[2] && value[2] > value[3];
            }

            @Override
            public ACQ_IConstraint getNegation() {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }

            @Override
            public void toChoco(Model model, IntVar... intVars) {
                model.arithm(intVars[0], Operator.GT.toString(), intVars[1]).post();
                model.arithm(intVars[1], Operator.GT.toString(), intVars[2]).post();
                model.arithm(intVars[2], Operator.GT.toString(), intVars[3]).post();
            }
        };
       ACQ_ConstraintSet constraints=new ACQ_ConstraintSet();
        constraints.add(constraint1);
        constraints.add(constraint2);
        constraints.add(constraint3);
        
        // Arithmetic constraints
        // A=2
        constraints.add(new UnaryArithmetic("EquX", 0, Operator.EQ, 2));
        // A != B
        constraints.add(new BinaryArithmetic("DifferentXY", 0, Operator.NQ, 1));
        // C>A+10
        constraints.add(new BinaryArithmetic("Formule",2,Operator.GT,0,Operator.PL,10));        
        ACQ_Network network=new ACQ_Network(constraints);
        network.printVariables();
    }
}
