package ag;

import java.util.BitSet;

import acqConstraints.Operator;
import combinatorial.AllPermutationIterator;
import combinatorial.CombinationIterator;
/**
 * Tests de la fonction getProjection(ACQ_Scope)
 * @author teddy
 *
 */
public class Test3 {
	public static void main (String[]args) {

		// Construction biais
		int NB_VARIABLE = 3;
		// build All variables set
		BitSet bs = new BitSet();
		bs.set(0, NB_VARIABLE);
		ACQ_Scope allVarSet = new ACQ_Scope(bs);
		// build Constraints
		ACQ_ConstraintSet constraints = new ACQ_ConstraintSet();
		CombinationIterator iterator = new CombinationIterator(NB_VARIABLE, 2);
		while (iterator.hasNext()) {
			int[] vars = iterator.next();
			AllPermutationIterator pIterator = new AllPermutationIterator(2);
			while (pIterator.hasNext()) {
				int[] pos = pIterator.next();
				// X != Y
				constraints.add(new BinaryArithmetic("DifferentXY", vars[pos[0]], Operator.NQ, vars[pos[1]]));
				// X == Y
				constraints.add(new BinaryArithmetic("EqualXY", vars[pos[0]], Operator.EQ, vars[pos[1]]));
				// X >= Y
				constraints.add(new BinaryArithmetic("GreaterEqualXY", vars[pos[0]], Operator.GE, vars[pos[1]]));
			}
		}
		ACQ_Network network = new ACQ_Network(allVarSet, constraints);
		ACQ_Bias bias = new ACQ_Bias(network);
		System.out.println(bias.network.toString());
		System.out.println("projection of "+ allVarSet.toString());
		ACQ_Network proj1 = bias.getProjection(allVarSet);
		System.out.println(proj1.toString());
		
		ACQ_Scope varSet1 = new ACQ_Scope(0,2);
		System.out.println("projection of "+varSet1.toString());
		ACQ_Network proj2 = bias.getProjection(varSet1);
		System.out.println(proj2.toString());
	}
}
